Subject: Re: bug#38167: guix pull takes over 8 GiB of memory to finish if there are no substitutes

From: Ludovic Courtès <[email-masked]>
Date: Mon, 11 Nov 2019 21:42:24 +0100

Hi Chris & Danny,

Christopher Baines <[email-masked]> skribis:

> Danny Milosavljevic <[email-masked]> writes:
>
>> Hi,
>>
>> guix pull takes over 8 GiB of memory to finish if there are no substitutes.
>>
>> My laptop only takes max 8 GiB of RAM.  I've set up swap, but that kind of
>> memory usage still seems ridiculous.
>
> Do you know if the derivations got built in parallel? So, does guix pull
> --max-jobs=1 use the same amount of memory?

Also, it would be great if you could identify which derivation build
requires that much memory, if this was happening sequentially.  (I
suspect “guix-packages.drv” is the one that eats up the most memory.)

I agree it’s ridiculous.  That memory usage comes from Guile’s
compiler.  A couple of years ago, Andy managed to cut memory usage
somewhat, but that’s not enough.

Thanks,
Ludo’.